using System;
using Syntriax.Modules.State;

namespace Syntriax.Modules.Action
{
    public interface IAction
    {
        /// <summary>
        /// The member <see cref="IStateEnable"/> the Action uses to check if it's active or not
        /// </summary>
        IStateEnable StateEnable { get; }

        /// <summary>
        /// Called when the <see cref="IAction"/> is Activated
        /// </summary>
        /// <value>The <see cref="IAction"/> that Activated</value>
        Action<IAction> OnActivated { get; set; }

        /// <summary>
        /// Triggers the <see cref="IAction"/>
        /// </summary>
        void Activate();
    }
}
